//+------------------------------------------------------------------
//|                                                     
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  DimGray
#property indicator_color2  DimGray
#property indicator_color3  DimGray
#property indicator_color4  DeepSkyBlue
#property indicator_color5  PaleVioletRed
#property indicator_color6  DeepSkyBlue
#property indicator_color7  PaleVioletRed
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_width6  2
#property indicator_width7  2

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame     = PERIOD_CURRENT;
extern int             HighLowPeriod = 10;
extern bool            Interpolate   = true;           // Interpolate in multi time frame mode

double peakUp[];
double peakDn[];
double legUp[];
double legDn[];
double limHi[];
double limMi[];
double limLo[];
double leg[];
double trend[];

string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(9);
      SetIndexBuffer(0,limHi);
      SetIndexBuffer(1,limMi);
      SetIndexBuffer(2,limLo);
      SetIndexBuffer(3,legUp);
      SetIndexBuffer(4,legDn);
      SetIndexBuffer(5,peakUp); SetIndexStyle(5,DRAW_ARROW); SetIndexArrow(5,159);
      SetIndexBuffer(6,peakDn); SetIndexStyle(6,DRAW_ARROW); SetIndexArrow(6,159);
      SetIndexBuffer(7,leg);
      SetIndexBuffer(8,trend);
      
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
      
      //
      //
      //
      //
      //
               
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,n,counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if (counted_bars>0) counted_bars--;
          int limit = MathMin(Bars-counted_bars,Bars-1);
          if (returnBars)
          {
            int count = 0;
               for (; limit<Bars && count <2; limit++)
               {
                  if (peakUp[limit] != EMPTY_VALUE) count ++;
                  if (peakDn[limit] != EMPTY_VALUE) count ++;
               }
               limHi[0] = limit;
               return(0); 
          }

   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
      for (i=limit; i>=0; i--)
      {
         peakUp[i] = EMPTY_VALUE;
         peakDn[i] = EMPTY_VALUE;
         limHi[i]  = High[ArrayMaximum(High,HighLowPeriod,i)];
         limLo[i]  = Low[ArrayMinimum(Low,HighLowPeriod,i)];
         limMi[i]  = (limHi[i]+limLo[i])/2.0;
         leg[i]    = leg[i+1];
      
         if (limHi[i] > limHi[i+1]) leg[i] = MathMax( 1,leg[i+1]+1);
         if (limLo[i] < limLo[i+1]) leg[i] = MathMin(-1,leg[i+1]-1);
         if (leg[i] > 0 && leg[i] != leg[i+1]) { if (leg[i]>1) cleanUppeak(i); peakUp[i] = High[i]; }
         if (leg[i] < 0 && leg[i] != leg[i+1]) { if (leg[i]<1) cleanDnpeak(i); peakDn[i] = Low[i];  }
         
         //
         //
         //
         //
         //
         
         trend[i] = trend[i+1];
         if (peakUp[i] != EMPTY_VALUE || peakDn[i] != EMPTY_VALUE)
         {
            if (peakUp[i] != EMPTY_VALUE)
            {
                  for(n = 1; i+n < Bars && peakUp[i+n]==EMPTY_VALUE; n++) continue; if (peakUp[i+n]<peakUp[i]) trend[i] = 1;
                  for(n = 1; i+n < Bars && peakDn[i+n]==EMPTY_VALUE; n++) continue;
            }
            if (peakDn[i] != EMPTY_VALUE)
            {
                  for(n = 1; i+n < Bars && peakDn[i+n]==EMPTY_VALUE; n++) continue; if (peakDn[i+n]>peakDn[i]) trend[i] = -1;
                  for(n = 1; i+n < Bars && peakUp[i+n]==EMPTY_VALUE; n++) continue;
            }
            
            //
            //
            //
            //
            //
            
            if (trend[i] == 1)
                  if (peakUp[i] != EMPTY_VALUE) 
                        { legUp[i] = peakUp[i]; legUp[i+n] = peakDn[i+n]; }
                  else  { legUp[i] = peakDn[i]; legUp[i+n] = peakUp[i+n]; }
            else
                  if (peakUp[i] != EMPTY_VALUE) 
                        { legDn[i] = peakUp[i]; legDn[i+n] = peakDn[i+n]; }
                  else  { legDn[i] = peakDn[i]; legDn[i+n] = peakUp[i+n]; }
            
            //
            //
            //
            //
            //
            
            for(int k = 1; k < n; k++)
            {
               if (trend[i] ==  1) { legUp[i+k] = legUp[i] + (legUp[i+n]-legUp[i])*k/n; legDn[i+k] = EMPTY_VALUE; }
  	            if (trend[i] == -1) { legDn[i+k] = legDn[i] + (legDn[i+n]-legDn[i])*k/n; legUp[i+k] = EMPTY_VALUE; }
            }  	            
         }               
      }
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      int x = iBarShift(NULL,TimeFrame,Time[i+1]);
         limHi[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,HighLowPeriod,0,y);
         limMi[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,HighLowPeriod,1,y);
         limLo[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,HighLowPeriod,2,y);
         trend[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,HighLowPeriod,8,y);
         peakUp[i] = EMPTY_VALUE;
         peakDn[i] = EMPTY_VALUE;
            if (x!=y)
            {
               peakUp[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,HighLowPeriod,5,y);
               peakDn[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,HighLowPeriod,6,y);
            }

      
         trend[i] = trend[i+1];
         if (peakUp[i] != EMPTY_VALUE || peakDn[i] != EMPTY_VALUE)
         {
            if (peakUp[i] != EMPTY_VALUE)
            {
                  for(n = 1; i+n < Bars && peakUp[i+n]==EMPTY_VALUE; n++) continue; if (peakUp[i+n]<peakUp[i]) trend[i] = 1;
                  for(n = 1; i+n < Bars && peakDn[i+n]==EMPTY_VALUE; n++) continue;
            }
            if (peakDn[i] != EMPTY_VALUE)
            {
                  for(n = 1; i+n < Bars && peakDn[i+n]==EMPTY_VALUE; n++) continue; if (peakDn[i+n]>peakDn[i]) trend[i] = -1;
                  for(n = 1; i+n < Bars && peakUp[i+n]==EMPTY_VALUE; n++) continue;
            }
            
            //
            //
            //
            //
            //
            
            if (trend[i] == 1)
                  if (peakUp[i] != EMPTY_VALUE) 
                        { legUp[i] = peakUp[i]; legUp[i+n] = peakDn[i+n]; }
                  else  { legUp[i] = peakDn[i]; legUp[i+n] = peakUp[i+n]; }
            else
                  if (peakUp[i] != EMPTY_VALUE) 
                        { legDn[i] = peakUp[i]; legDn[i+n] = peakDn[i+n]; }
                  else  { legDn[i] = peakDn[i]; legDn[i+n] = peakUp[i+n]; }
            
            //
            //
            //
            //
            //
            
            for(k = 1; k < n; k++)
            {
               if (trend[i] ==  1) { legUp[i+k] = legUp[i] + (legUp[i+n]-legUp[i])*k/n; legDn[i+k] = EMPTY_VALUE; }
  	            if (trend[i] == -1) { legDn[i+k] = legDn[i] + (legDn[i+n]-legDn[i])*k/n; legUp[i+k] = EMPTY_VALUE; }
            }  	            
         }               
         if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; i+k < Bars && i+n < Bars && k < n; k++)
            {
               limHi[i+k] = limHi[i] + (limHi[i+n] - limHi[i])*k/n;
               limMi[i+k] = limMi[i] + (limMi[i+n] - limMi[i])*k/n;
               limLo[i+k] = limLo[i] + (limLo[i+n] - limLo[i])*k/n;
            }
   }
   return(0);         
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void cleanUppeak(int i)
{
   for (int k=i+1; k<Bars && peakDn[k]==EMPTY_VALUE; k++) 
         if (peakUp[k] != EMPTY_VALUE) { peakUp[k]=EMPTY_VALUE; break; }
}
void cleanDnpeak(int i)
{
   for (int k=i+1; k<Bars && peakUp[k]==EMPTY_VALUE; k++) 
         if (peakDn[k] != EMPTY_VALUE) { peakDn[k]=EMPTY_VALUE; break; }
}